// AplDoc.cpp : implementation of the CAplDoc class
//

#include "stdafx.h"
#include "Apl.h"
#include "AplDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAplDoc

IMPLEMENT_DYNCREATE(CAplDoc, CDocument)

BEGIN_MESSAGE_MAP(CAplDoc, CDocument)
   //{{AFX_MSG_MAP(CAplDoc)
	ON_COMMAND(ID_SELECTFONT, OnSelectFont)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAplDoc construction/destruction

CAplDoc::CAplDoc()
{
   m_pSelectProcess = NULL;

// create an instance of the font helper
   m_pFontHelper = new CFontHelper(_T("Settings"), _T("Font"));
}

CAplDoc::~CAplDoc()
{
// get rid of the font helper after having saved it
   if (m_pFontHelper != NULL)
   {
      m_pFontHelper->Save();
      delete m_pFontHelper;
   }
}

BOOL CAplDoc::OnNewDocument()
{
// default MFC processing
   if (!CDocument::OnNewDocument())
      return FALSE;

// fill the process list
   m_ProcessList.Refresh();

// initialization is successful
   return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAplDoc diagnostics

#ifdef _DEBUG
void CAplDoc::AssertValid() const
{
   CDocument::AssertValid();
}

void CAplDoc::Dump(CDumpContext& dc) const
{
   CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAplDoc commands

void CAplDoc::SetCurrentProcess(CView* pView, CProcess* pProcess)
{
// store it 
   m_pSelectProcess = pProcess;

// notify all views except pView
   UpdateAllViews(pView, VM_SET_CURRENT_PROCESS, pProcess);
}

void CAplDoc::NotifyDefaultFont()
{
// defensive programming
   ASSERT(m_pFontHelper != NULL);

// use the font helper to get the font
   if (m_pFontHelper != NULL)
   {
   // dispatch new font to each view
      SetCurrentFont();
   }
}

void CAplDoc::OnSelectFont() 
{
// defensive programming
   ASSERT(m_pFontHelper != NULL);

// use the font helper to ask the user for a new font
   if (m_pFontHelper != NULL)
   {
      if (m_pFontHelper->ChooseFont())
      // dispatch new font to every views
         SetCurrentFont();
   }
}

// change the current font for all views
void CAplDoc::SetCurrentFont()
{
// defensive programming
   ASSERT(m_pFontHelper != NULL);

// send the font to every views
   if (m_pFontHelper != NULL)
      UpdateAllViews(NULL, VM_CHANGEFONT, (CObject*)m_pFontHelper->GetFontHandle());
}

