// AplDoc.h : interface of the CAplDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_APLDOC_H__AF3C926A_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_)
#define AFX_APLDOC_H__AF3C926A_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Process.h"
#include "FontHelper.h"

//                           lHint          pHint   Event meaning
//--------------------------------   ------------   -----------------------------------
#define VM_REDRAW                0   // 0           standard MFC redrawing notification
#define VM_SET_CURRENT_PROCESS   1   // CProcess*   current process has changed (or NULL)
#define VM_CHANGEFONT            2   // hFont       font has changed

class CAplDoc : public CDocument
{
protected: // create from serialization only
   CAplDoc();
   DECLARE_DYNCREATE(CAplDoc)

// Attributes
public:

// Operations
public:
// font management
   void NotifyDefaultFont();
   void SetCurrentFont();

// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CAplDoc)
   public:
   virtual BOOL OnNewDocument();
   //}}AFX_VIRTUAL

// Implementation
public:
   virtual ~CAplDoc();
   CProcessList& GetProcessList() { return m_ProcessList; }
   CProcess* GetSelectedProcess() { return m_pSelectProcess; }
   void SetCurrentProcess(CView* pView, CProcess* pProcess);

#ifdef _DEBUG
   virtual void AssertValid() const;
   virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   CProcessList   m_ProcessList;
   CProcess*      m_pSelectProcess;
   CFontHelper*   m_pFontHelper;

// Generated message map functions
protected:
   //{{AFX_MSG(CAplDoc)
   afx_msg void OnSelectFont();
    //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_APLDOC_H__AF3C926A_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_)
