// AplView.h : interface of the CAplView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_APLVIEW_H__AF3C926C_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_)
#define AFX_APLVIEW_H__AF3C926C_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// content of each column
#define COLUMN_NAME               0
#define COLUMN_PID                1
#define COLUMN_FILENAME           2
#define COLUMN_WINDOW             3
#define COLUMN_WORKINGSET         4
#define COLUMN_HANDLECOUNT        5
#define COLUMN_PARENTPROCESS      6

class CAplView : public CListView
{
protected: // create from serialization only
   CAplView();
   DECLARE_DYNCREATE(CAplView)

// Attributes
public:
   CAplDoc* GetDocument();

// Operations
public:
   LPTSTR GetClipboardString();

// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CAplView)
    public:
   virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    protected:
   virtual void OnInitialUpdate(); // called first time after construct
    virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
    //}}AFX_VIRTUAL

// Implementation
public:
   int InsertItem(LPVOID pItem, int nItem);
   virtual ~CAplView();
#ifdef _DEBUG
   virtual void AssertValid() const;
   virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   BOOL m_bNoSelection;

// Generated message map functions
protected:
   virtual void OnNeedText(LPVOID pItem, int nColumn, CString& szContent);
   int FillList();

   // process/list view cross reference map
   CTypedPtrMap<CMapPtrToPtr, DWORD, int> m_ProcessIndex;
   //{{AFX_MSG(CAplView)
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
   afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnEditCopy();
    //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in AplView.cpp
inline CAplDoc* CAplView::GetDocument()
   { return (CAplDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_APLVIEW_H__AF3C926C_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_)
