// ParentView.h : interface of the CParentView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARENTVIEW_H__AF3C926E_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_)
#define AFX_PARENTVIEW_H__AF3C926E_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PICTURE_WIDTH   18  // width of each picture
#define STATE_PARENT     0  // picture index for a parent process
#define STATE_CHILD      1  // picture index for a child process
#define STATE_ROOT       2  // picture index for the root

#include "Process.h"

class CAplDoc;

class CParentView : public CTreeView
{
protected: // create from serialization only
   CParentView();
   DECLARE_DYNCREATE(CParentView)

// Attributes
public:
   CAplDoc* GetDocument();

// Operations
public:

// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CParentView)
	public:
   virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
   virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
   virtual ~CParentView();
   void FillParentTree();
   HTREEITEM InsertProcess(DWORD PID, CProcessList&  ProcessList,
	   CTypedPtrMap<CMapPtrToPtr, DWORD, HTREEITEM>& InsertedProcesses,
	   CMapPtrToPtr&  Children);
   
#ifdef _DEBUG
   virtual void AssertValid() const;
   virtual void Dump(CDumpContext& dc) const;
#endif

protected:
   BOOL m_bNoSelection;
   CImageList m_TreeImages;     // image list used for the tree view

// given a PID, return a HTREEITEM
   CTypedPtrMap<CMapPtrToPtr, DWORD, HTREEITEM> m_ProcessItems;

// root of all processes
   HTREEITEM m_hRoot;

// Generated message map functions
protected:
   virtual void OnNeedText(LPVOID pItem, CString& szText);
   //{{AFX_MSG(CParentView)
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
   afx_msg void OnDestroy();
   afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ParentView.cpp
inline CAplDoc* CParentView::GetDocument()
   { return (CAplDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PARENTVIEW_H__AF3C926E_6A59_11D2_A0A4_00A0C94CB8B3__INCLUDED_)
